<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>JType.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler</a> &gt; <span class="el_source">JType.java</span></div><h1>JType.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler;

/**
 * Abstract Base class for all types supported by Hadoop Record I/O.
 * 
 */
abstract public class JType {
    
	private String mCName;
    private String mCppName;
    private String mCsharpName;
    private String mJavaName;
    protected String mMethodSuffix;
    private String mWrapper;
    private String mSharpWrapper;
    private String mUnwrapMethod;

    /**
     * Creates a new instance of JType
     */
<span class="nc" id="L39">    JType(String cname, String cppname, String csharpName, String javaname, String suffix, String wrapper, String csharpWrapper, String unwrap) {</span>
<span class="nc" id="L40">    	mCName = cname;</span>
<span class="nc" id="L41">        mCppName = cppname;</span>
<span class="nc bnc" id="L42" title="All 2 branches missed.">        mCsharpName = &quot;Id&quot;.equals(csharpName) ? &quot;ZKId&quot; : csharpName;</span>
<span class="nc" id="L43">        mJavaName = javaname;</span>
<span class="nc" id="L44">        mMethodSuffix = suffix;</span>
<span class="nc" id="L45">        mWrapper = wrapper;</span>
<span class="nc" id="L46">        mSharpWrapper = csharpWrapper;</span>
<span class="nc" id="L47">        mUnwrapMethod = unwrap;</span>
<span class="nc" id="L48">    }</span>
    
    abstract String getSignature();
    
    String genCppDecl(String fname) {
<span class="nc" id="L53">        return &quot;  &quot;+mCppName+&quot; m&quot;+fname+&quot;;\n&quot;; </span>
    }
    
	String genCDecl(String name) {
<span class="nc" id="L57">		return &quot;    &quot; + mCName + &quot; &quot;+name+&quot;;\n&quot;; </span>
	}

    public String genCsharpDecl(String name) {
<span class="nc" id="L61">        return &quot;  private &quot;+mCsharpName+&quot; &quot; +name+&quot;;\n&quot;;</span>
    }

    String genJavaDecl (String fname) {
<span class="nc" id="L65">        return &quot;  private &quot;+mJavaName+&quot; &quot; +fname+&quot;;\n&quot;;</span>
    }
    
    String genJavaConstructorParam (String fname) {
<span class="nc" id="L69">        return &quot;        &quot;+mJavaName+&quot; &quot;+fname;</span>
    }
    
    String genCppGetSet(String fname, int fIdx) {
<span class="nc" id="L73">        String getFunc = &quot;  virtual &quot;+mCppName+&quot; get&quot;+fname+&quot;() const {\n&quot;;</span>
<span class="nc" id="L74">        getFunc += &quot;    return m&quot;+fname+&quot;;\n&quot;;</span>
<span class="nc" id="L75">        getFunc += &quot;  }\n&quot;;</span>
<span class="nc" id="L76">        String setFunc = &quot;  virtual void set&quot;+fname+&quot;(&quot;+mCppName+&quot; m_) {\n&quot;;</span>
<span class="nc" id="L77">        setFunc += &quot;    m&quot;+fname+&quot;=m_; bs_.set(&quot;+fIdx+&quot;);\n&quot;;</span>
<span class="nc" id="L78">        setFunc += &quot;  }\n&quot;;</span>
<span class="nc" id="L79">        return getFunc+setFunc;</span>
    }

    String genCsharpGetSet(String fname, int fIdx) {
<span class="nc" id="L83">        String getFunc = &quot;  public &quot; + getCsharpType() + &quot; &quot; + capitalize(fname) + &quot; { get; set; } &quot;;</span>
<span class="nc" id="L84">        return getFunc;</span>
    }
    
    static String capitalize(String s) {
<span class="nc" id="L88">        return s.substring(0,1).toUpperCase()+s.substring(1);</span>
    }
    String genJavaGetSet(String fname, int fIdx) {
<span class="nc" id="L91">        String getFunc = &quot;  public &quot;+mJavaName+&quot; get&quot;+capitalize(fname)+&quot;() {\n&quot;;</span>
<span class="nc" id="L92">        getFunc += &quot;    return &quot;+fname+&quot;;\n&quot;;</span>
<span class="nc" id="L93">        getFunc += &quot;  }\n&quot;;</span>
<span class="nc" id="L94">        String setFunc = &quot;  public void set&quot;+capitalize(fname)+&quot;(&quot;+mJavaName+&quot; m_) {\n&quot;;</span>
<span class="nc" id="L95">        setFunc += &quot;    &quot; + fname+&quot;=m_;\n&quot;;</span>
<span class="nc" id="L96">        setFunc += &quot;  }\n&quot;;</span>
<span class="nc" id="L97">        return getFunc+setFunc;</span>
    }
    
    String getCType() {
<span class="nc" id="L101">    	return mCName;</span>
    }
    String getCppType() {
<span class="nc" id="L104">        return mCppName;</span>
    }
    
    String getCsharpType() {
<span class="nc" id="L108">        return mCsharpName;</span>
    }

    String getJavaType() {
<span class="nc" id="L112">        return mJavaName;</span>
    }
   
    String getJavaWrapperType() {
<span class="nc" id="L116">        return mWrapper;</span>
    }

    String getCsharpWrapperType() {
<span class="nc" id="L120">        return mSharpWrapper;</span>
    }
    
    String getMethodSuffix() {
<span class="nc" id="L124">        return mMethodSuffix;</span>
    }
    
    String genJavaWriteMethod(String fname, String tag) {
<span class="nc" id="L128">        return &quot;    a_.write&quot;+mMethodSuffix+&quot;(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }
    
    String genJavaReadMethod(String fname, String tag) {
<span class="nc" id="L132">        return &quot;    &quot;+fname+&quot;=a_.read&quot;+mMethodSuffix+&quot;(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }
    
    String genJavaReadWrapper(String fname, String tag, boolean decl) {
<span class="nc" id="L136">        String ret = &quot;&quot;;</span>
<span class="nc bnc" id="L137" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L138">            ret = &quot;    &quot;+mWrapper+&quot; &quot;+fname+&quot;;\n&quot;;</span>
        }
<span class="nc" id="L140">        return ret + &quot;    &quot;+fname+&quot;=new &quot;+mWrapper+&quot;(a_.read&quot;+mMethodSuffix+&quot;(\&quot;&quot;+tag+&quot;\&quot;));\n&quot;;</span>
    }
    
    String genJavaWriteWrapper(String fname, String tag) {
<span class="nc" id="L144">        return &quot;        a_.write&quot;+mMethodSuffix+&quot;(&quot;+fname+&quot;.&quot;+mUnwrapMethod+&quot;(),\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }
    
    String genJavaCompareTo(String fname) {
<span class="nc" id="L148">        return &quot;    ret = (&quot;+fname+&quot; == peer.&quot;+fname+&quot;)? 0 :((&quot;+fname+&quot;&lt;peer.&quot;+fname+&quot;)?-1:1);\n&quot;;</span>
    }
    
    String genJavaEquals(String fname, String peer) {
<span class="nc" id="L152">        return &quot;    ret = (&quot;+fname+&quot;==&quot;+peer+&quot;);\n&quot;;</span>
    }
    
    String genJavaHashCode(String fname) {
<span class="nc" id="L156">        return &quot;    ret = (int)&quot;+fname+&quot;;\n&quot;;</span>
    }

    String genJavaConstructorSet(String fname, String name) {
<span class="nc" id="L160">        return &quot;    this.&quot;+fname+&quot;=&quot;+name+&quot;;\n&quot;;</span>
    }

    String genCsharpWriteMethod(String fname, String tag) {
<span class="nc" id="L164">        return &quot;    a_.Write&quot;+mMethodSuffix+&quot;(&quot;+capitalize(fname)+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }

    String genCsharpReadMethod(String fname, String tag) {
<span class="nc" id="L168">        return &quot;    &quot;+capitalize(fname)+&quot;=a_.Read&quot;+mMethodSuffix+&quot;(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }

    String genCsharpReadWrapper(String fname, String tag, boolean decl) {
<span class="nc" id="L172">        String ret = &quot;&quot;;</span>
<span class="nc bnc" id="L173" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L174">            ret = &quot;    &quot;+mWrapper+&quot; &quot;+fname+&quot;;\n&quot;;</span>
        }
<span class="nc" id="L176">        return ret + &quot;    &quot;+fname+&quot;=a_.Read&quot;+mMethodSuffix+&quot;(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }

    String genCsharpWriteWrapper(String fname, String tag) {
<span class="nc bnc" id="L180" title="All 2 branches missed.">        if (mUnwrapMethod == null) return &quot;        a_.Write&quot;+mMethodSuffix+&quot;(&quot;+fname+&quot;,&quot;+tag+&quot;);\n&quot;;</span>
<span class="nc" id="L181">        return &quot;        a_.Write&quot;+mMethodSuffix+&quot;(&quot;+fname+&quot;.&quot;+mUnwrapMethod+&quot;(),\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }

    String genCsharpCompareTo(String name) {
<span class="nc" id="L185">        return &quot;    ret = (&quot;+capitalize(name)+&quot; == peer.&quot;+capitalize(name)+&quot;)? 0 :((&quot;+capitalize(name)+&quot;&lt;peer.&quot;+capitalize(name)+&quot;)?-1:1);\n&quot;;</span>
    }

    String genCsharpEquals(String name, String peer) {
<span class="nc" id="L189">        String[] peerSplit = peer.split(&quot;\\.&quot;);</span>
<span class="nc" id="L190">        return &quot;    ret = (&quot;+capitalize(name)+&quot;==&quot;+peerSplit[0] + &quot;.&quot; + capitalize(peerSplit[1]) + &quot;);\n&quot;;</span>
    }

    String genCsharpHashCode(String fname) {
<span class="nc" id="L194">        return &quot;    ret = (int)&quot;+capitalize(fname)+&quot;;\n&quot;;</span>
    }

    String genCsharpConstructorSet(String mName, String fname) {
<span class="nc" id="L198">        return capitalize(fname)+&quot;=&quot;+mName+&quot;;\n&quot;;</span>
    }

    public String genCsharpConstructorParam(String fname) {
<span class="nc" id="L202">        return &quot;  &quot;+mCsharpName+&quot; &quot; +fname+&quot;\n&quot;;</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>